Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
    Public DeviceIndex As UInteger

	Dim DIOData As Integer
	Dim DoUpdate As Boolean
	Public DetectOK As Boolean
	
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim OutMask As Byte
		Dim I As Short
		Dim Status As Integer
		
		
		DeviceIndex = diOnly
		
		OutMask = 0
		DIOData = &HFFFFs
		
		Status = DIO_Configure(DeviceIndex, False, OutMask, DIOData)
		
		DoUpdate = True
		ReadTime.Enabled = True
		
	End Sub
	
	Private Sub LevelImage_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles LevelImage.Click
		Dim Index As Short = LevelImage.GetIndex(eventSender)
		Dim NewValue As Boolean
		
        DIOData = DIOData Xor (Index << 1)
        NewValue = (DIOData And (Index << 1)) <> 0
		DIO_Write1(DeviceIndex, Index, NewValue)
		DoUpdate = True
		
	End Sub
	
	'UPGRADE_WARNING: Event OutCheck.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub OutCheck_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OutCheck.CheckStateChanged
		Dim Index As Short = OutCheck.GetIndex(eventSender)
		Dim OutMask As Byte
		Dim I As Short
		
		
		
		OutMask = 0
		
		For I = 0 To 1
			If OutCheck(I).CheckState = System.Windows.Forms.CheckState.Checked Then
                OutMask = OutMask Or (I << 1)
			End If
		Next I
		
        DIOData = DIOData Or (&HFFS << Index * 8)
		DIO_Configure(DeviceIndex, False, OutMask, DIOData)
		DoUpdate = True
		
		
	End Sub
	
	Private Sub ReadTime_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ReadTime.Tick
		Dim I As Short
		Dim oDIOData As Integer
		Dim Changes As Integer
		
		oDIOData = DIOData
		
		DIO_ReadAll(DeviceIndex, DIOData)
		
		Changes = DIOData Xor oDIOData
		
		If DoUpdate = True Then
			Changes = &HFFFFs
			DoUpdate = False
		End If
		
		For I = 0 To 15
            If (Changes And (1 << I)) <> 0 Then
                If (DIOData And (1 << I)) <> 0 Then
                    LevelImage(I).Image = HighImage.Image
                Else
                    LevelImage(I).Image = LowImage.Image
                End If
            End If
		Next I
		
	End Sub
End Class